/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { WEN_NEW_STANDARD_PROGRAM_ADDRESS } from '../programs';
export type ApproveTransferInstruction<TProgram extends string = typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountApproveAccount extends string | IAccountMeta<string> = string, TAccountPaymentMint extends string | IAccountMeta<string> = string, TAccountDistributionTokenAccount extends string | IAccountMeta<string> = string, TAccountAuthorityTokenAccount extends string | IAccountMeta<string> = string, TAccountDistributionAccount extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountDistributionProgram extends string | IAccountMeta<string> = 'diste3nXmK7ddDTs1zb6uday6j4etCa9RChD8fJ1xay', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb', TAccountPaymentTokenProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? WritableSignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountApproveAccount extends string ? WritableAccount<TAccountApproveAccount> : TAccountApproveAccount,
    TAccountPaymentMint extends string ? ReadonlyAccount<TAccountPaymentMint> : TAccountPaymentMint,
    TAccountDistributionTokenAccount extends string ? WritableAccount<TAccountDistributionTokenAccount> : TAccountDistributionTokenAccount,
    TAccountAuthorityTokenAccount extends string ? WritableAccount<TAccountAuthorityTokenAccount> : TAccountAuthorityTokenAccount,
    TAccountDistributionAccount extends string ? WritableAccount<TAccountDistributionAccount> : TAccountDistributionAccount,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountDistributionProgram extends string ? ReadonlyAccount<TAccountDistributionProgram> : TAccountDistributionProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountPaymentTokenProgram extends string ? ReadonlyAccount<TAccountPaymentTokenProgram> : TAccountPaymentTokenProgram,
    ...TRemainingAccounts
]>;
export type ApproveTransferInstructionData = {
    discriminator: ReadonlyUint8Array;
    buyAmount: bigint;
};
export type ApproveTransferInstructionDataArgs = {
    buyAmount: number | bigint;
};
export declare function getApproveTransferInstructionDataEncoder(): Encoder<ApproveTransferInstructionDataArgs>;
export declare function getApproveTransferInstructionDataDecoder(): Decoder<ApproveTransferInstructionData>;
export declare function getApproveTransferInstructionDataCodec(): Codec<ApproveTransferInstructionDataArgs, ApproveTransferInstructionData>;
export type ApproveTransferInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountMint extends string = string, TAccountApproveAccount extends string = string, TAccountPaymentMint extends string = string, TAccountDistributionTokenAccount extends string = string, TAccountAuthorityTokenAccount extends string = string, TAccountDistributionAccount extends string = string, TAccountSystemProgram extends string = string, TAccountDistributionProgram extends string = string, TAccountTokenProgram extends string = string, TAccountPaymentTokenProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    mint: Address<TAccountMint>;
    approveAccount: Address<TAccountApproveAccount>;
    paymentMint: Address<TAccountPaymentMint>;
    distributionTokenAccount?: Address<TAccountDistributionTokenAccount>;
    authorityTokenAccount?: Address<TAccountAuthorityTokenAccount>;
    distributionAccount: Address<TAccountDistributionAccount>;
    systemProgram?: Address<TAccountSystemProgram>;
    distributionProgram?: Address<TAccountDistributionProgram>;
    tokenProgram?: Address<TAccountTokenProgram>;
    paymentTokenProgram?: Address<TAccountPaymentTokenProgram>;
    buyAmount: ApproveTransferInstructionDataArgs['buyAmount'];
};
export declare function getApproveTransferInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountMint extends string, TAccountApproveAccount extends string, TAccountPaymentMint extends string, TAccountDistributionTokenAccount extends string, TAccountAuthorityTokenAccount extends string, TAccountDistributionAccount extends string, TAccountSystemProgram extends string, TAccountDistributionProgram extends string, TAccountTokenProgram extends string, TAccountPaymentTokenProgram extends string>(input: ApproveTransferInput<TAccountPayer, TAccountAuthority, TAccountMint, TAccountApproveAccount, TAccountPaymentMint, TAccountDistributionTokenAccount, TAccountAuthorityTokenAccount, TAccountDistributionAccount, TAccountSystemProgram, TAccountDistributionProgram, TAccountTokenProgram, TAccountPaymentTokenProgram>): ApproveTransferInstruction<typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountPayer, TAccountAuthority, TAccountMint, TAccountApproveAccount, TAccountPaymentMint, TAccountDistributionTokenAccount, TAccountAuthorityTokenAccount, TAccountDistributionAccount, TAccountSystemProgram, TAccountDistributionProgram, TAccountTokenProgram, TAccountPaymentTokenProgram>;
export type ParsedApproveTransferInstruction<TProgram extends string = typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        mint: TAccountMetas[2];
        approveAccount: TAccountMetas[3];
        paymentMint: TAccountMetas[4];
        distributionTokenAccount?: TAccountMetas[5] | undefined;
        authorityTokenAccount?: TAccountMetas[6] | undefined;
        distributionAccount: TAccountMetas[7];
        systemProgram: TAccountMetas[8];
        distributionProgram: TAccountMetas[9];
        tokenProgram: TAccountMetas[10];
        paymentTokenProgram?: TAccountMetas[11] | undefined;
    };
    data: ApproveTransferInstructionData;
};
export declare function parseApproveTransferInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedApproveTransferInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=approveTransfer.d.ts.map