/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { WEN_NEW_STANDARD_PROGRAM_ADDRESS } from '../programs';
export type CreateMintAccountInstruction<TProgram extends string = typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountReceiver extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMintTokenAccount extends string | IAccountMeta<string> = string, TAccountManager extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountReceiver extends string ? ReadonlyAccount<TAccountReceiver> : TAccountReceiver,
    TAccountMint extends string ? WritableSignerAccount<TAccountMint> & IAccountSignerMeta<TAccountMint> : TAccountMint,
    TAccountMintTokenAccount extends string ? WritableAccount<TAccountMintTokenAccount> : TAccountMintTokenAccount,
    TAccountManager extends string ? ReadonlyAccount<TAccountManager> : TAccountManager,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type CreateMintAccountInstructionData = {
    discriminator: ReadonlyUint8Array;
    name: string;
    symbol: string;
    uri: string;
    permanentDelegate: Option<Address>;
};
export type CreateMintAccountInstructionDataArgs = {
    name: string;
    symbol: string;
    uri: string;
    permanentDelegate: OptionOrNullable<Address>;
};
export declare function getCreateMintAccountInstructionDataEncoder(): Encoder<CreateMintAccountInstructionDataArgs>;
export declare function getCreateMintAccountInstructionDataDecoder(): Decoder<CreateMintAccountInstructionData>;
export declare function getCreateMintAccountInstructionDataCodec(): Codec<CreateMintAccountInstructionDataArgs, CreateMintAccountInstructionData>;
export type CreateMintAccountInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountReceiver extends string = string, TAccountMint extends string = string, TAccountMintTokenAccount extends string = string, TAccountManager extends string = string, TAccountSystemProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountTokenProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    receiver: Address<TAccountReceiver>;
    mint: TransactionSigner<TAccountMint>;
    mintTokenAccount: Address<TAccountMintTokenAccount>;
    manager: Address<TAccountManager>;
    systemProgram?: Address<TAccountSystemProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    tokenProgram?: Address<TAccountTokenProgram>;
    name: CreateMintAccountInstructionDataArgs['name'];
    symbol: CreateMintAccountInstructionDataArgs['symbol'];
    uri: CreateMintAccountInstructionDataArgs['uri'];
    permanentDelegate: CreateMintAccountInstructionDataArgs['permanentDelegate'];
};
export declare function getCreateMintAccountInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountReceiver extends string, TAccountMint extends string, TAccountMintTokenAccount extends string, TAccountManager extends string, TAccountSystemProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountTokenProgram extends string>(input: CreateMintAccountInput<TAccountPayer, TAccountAuthority, TAccountReceiver, TAccountMint, TAccountMintTokenAccount, TAccountManager, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTokenProgram>): CreateMintAccountInstruction<typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountPayer, TAccountAuthority, TAccountReceiver, TAccountMint, TAccountMintTokenAccount, TAccountManager, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTokenProgram>;
export type ParsedCreateMintAccountInstruction<TProgram extends string = typeof WEN_NEW_STANDARD_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        receiver: TAccountMetas[2];
        mint: TAccountMetas[3];
        mintTokenAccount: TAccountMetas[4];
        manager: TAccountMetas[5];
        systemProgram: TAccountMetas[6];
        associatedTokenProgram: TAccountMetas[7];
        tokenProgram: TAccountMetas[8];
    };
    data: CreateMintAccountInstructionData;
};
export declare function parseCreateMintAccountInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateMintAccountInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createMintAccount.d.ts.map